#fit our proposed model using the fully Bayesian approach with NNGP
rm(list=ls(all=TRUE))

dir0="C:/eco fal/"
dir1="C:/eco fal/GP_results/"
dir="C:/eco fal/results/"

library(pscl)
###################################################
#1. some useful functions
##(1.1)update phi in GP, PP
post_phi2=function(star,phi_in,c_in,d_in,dist_AN_in,dist_NN_in,NNset_in,sigma2_in,mu_in,X_in,X_R_in,e_in,f_in)
{
 part11=(c_in-1)*log(star)-d_in*star
 part12=(c_in-1)*log(phi_in)-d_in*phi_in
 part41=(e_in-1)*log(star)-f_in*star
 part42=(e_in-1)*log(phi_in)-f_in*phi_in
 A=length(X_in)
 R=length(X_R_in)
 H_A_vec1=H_A_vec2=rep(0,A)
 B_A1=B_A2=matrix(0,nrow=A,ncol=R)
 for(a in 1:A)
 {
  nnnum=NNset_in[,a]
  theHa=exp(-phi_in*dist_AN_in[[a]])
  thenn=solve(exp(-phi_in*dist_NN_in[[a]]))
  theres=t(theHa)%*%thenn
  B_A2[a,nnnum]=theres
  H_A_vec2[a]=(1-theres%*%theHa)[1,1]
  theHa=exp(-star*dist_AN_in[[a]])
  thenn=solve(exp(-star*dist_NN_in[[a]]))
  theres=t(theHa)%*%thenn
  H_A_vec1[a]=(1-theres%*%theHa)[1,1]
  B_A1[a,nnnum]=theres
 }
 E_A1=mu_in+apply(t(B_A1)*(X_R_in-mu_in),2,sum)
 E_A2=mu_in+apply(t(B_A2)*(X_R_in-mu_in),2,sum)
 d1=prod(H_A_vec1)
 d2=prod(H_A_vec2)
 if((d1==0)&(d2==0))
 {
  part2=0
 }
 else
 {
  part2=0.5*(log(d1)-log(d2))
 }
 part31=(-0.5)/sigma2_in*sum((X_in-E_A1)^2/H_A_vec1)
 part32=(-0.5)/sigma2_in*sum((X_in-E_A2)^2/H_A_vec2)
 res=part11-part12-part2+part31-part32-part41+part42
 return(res)
}
update_phi2=function(phi_in,c_in,d_in,dist_AN_in,dist_NN_in,NNset_in,sigma2_in,mu_in,X_in,X_R_in,e_in,f_in,acc_phi_in)
{
  #get proposal
  thestar=0
  while(thestar<0.0001)
  {
   thestar=rgamma(1,shape=e_in,rate=f_in)
  }
  logrr=post_phi2(thestar,phi_in,c_in,d_in,dist_AN_in,dist_NN_in,NNset_in,sigma2_in,mu_in,X_in,X_R_in,e_in,f_in)
  logu=log(runif(1,0,1))
  if(logrr>logu)
  {
   phi_in=thestar
   acc_phi_in=acc_phi_in+1
  }
  return(list(phi_in,acc_phi_in))
}
##(1.2)to update eta
post_eta=function(theeta,k,W,eta_in,beta_in,X_in,tau_in,index)
{
 #theeta is the current value of eta[k], k the index of eta
 #if index=1, then X_in[k] is a number
 #if index>1, then X_in[[k]] is a vector, the grids in region k
 thesum=sum(W[k,])
 etabar=((W[k,]%*%eta_in)/thesum)[1,1]
 if(index==1)
 {
  theprob=(1+exp(-(beta_in[1]+beta_in[2]*X_in[k]+theeta)))^(-1)
 }
 if(index>1)
 {
  theprob=mean((1+exp(-(beta_in[1]+beta_in[2]*X_in[[k]]+theeta)))^(-1))
 }
 part1=0.5*tau_in*thesum*(theeta-etabar)^2
 part2=Y[k]*log(theprob)
 part3=(N[k]-Y[k])*log(1-theprob)
 res=part1*(-1)+part2+part3
 if(res==-Inf)
 {
  res=-9999999999999
 }
 if(res==Inf)
 {
  res=9999999999999
 }
 return(res)
}
update_eta=function(W,eta_in,beta_in,X_in,tau_in,omega_in,acc_eta_in,index)
{
  #update each eta[i]
  #omega is the variance for proposal dist
  for(k in 1:K)
  {
   #get proposal
   thecurr=eta_in[k]
   thestar=rnorm(1,thecurr,omega_in[k])
   logA=post_eta(thestar,k,W,eta_in,beta_in,X_in,tau_in,index)
   logB=post_eta(thecurr,k,W,eta_in,beta_in,X_in,tau_in,index)
   logrr=logA-logB
   logu=log(runif(1,0,1))
   if(logrr>logu)
   {
    eta_in[k]=thestar
    acc_eta_in[k]=acc_eta_in[k]+1
   }
  }
  #then centering eta
  eta_in=eta_in-mean(eta_in)
  return(list(eta_in,acc_eta_in))
}

##(1.3)to update beta
post_beta=function(thebeta,i,eta_in,beta_in,X_in,index)
{
 #thebeta is the current value of beta[i], i the index of beta
 newbeta=beta_in
 newbeta[i]=thebeta
 if(index==1)
 {
  probmat=(1+exp(-(newbeta[1]+newbeta[2]*X_in+eta_in)))^(-1)
 }
 if(index>1)
 {
  probmat=rep(0,K)
  for(k in 1:K)
  {
   probmat[k]=mean((1+exp(-(newbeta[1]+newbeta[2]*X_in[[k]]+eta_in[k])))^(-1))
  }
 }
 a=Y*log(probmat)
 b=(N-Y)*log(1-probmat)
 part1=sum(a)
 part2=sum(b)
 res=part1+part2
 if(res==-Inf)
 {
  res=-9999999999999
 }
 if(res==Inf)
 {
  res=9999999999999
 }
 return(res)
}
update_beta=function(eta_in,beta_in,X_in,omega_in,acc_beta_in,index)
{
  #update each beta[i]
  #omega is the variance for proposal dist
  P=length(beta_in)
  for(i in 1:P)
  {
   #get proposal
   thecurr=beta_in[i]
   thestar=rnorm(1,thecurr,omega_in[i])
   logA=post_beta(thestar,i,eta_in,beta_in,X_in,index)
   logB=post_beta(thecurr,i,eta_in,beta_in,X_in,index)
   logrr=logA-logB
   logu=log(runif(1,0,1))
   if(logrr>logu)
   {
    beta_in[i]=thestar
    acc_beta_in[i]=acc_beta_in[i]+1
   }
  }
  return(list(beta_in,acc_beta_in))
}

##(1.4)to update tau
update_tau=function(eta_in,a,b,W)
{
  #calculte(eta_i-eta_j)^2
  K=length(eta_in)
  etalist=rep(eta_in,K)
  p1=matrix(etalist,nrow=K,ncol=K,byrow=T)
  p2=matrix(etalist,nrow=K,ncol=K,byrow=F)
  pp=(p1-p2)^2
  ppp=pp[lower.tri(pp)]
  www=W[lower.tri(W)]
  newb=b+sum(ppp*www)/2
  newa=a+K/2
  newtau=rgamma(1,newa,newb)
  return(newtau)
}

##(1.5)updata X_grid in NNGP, for each entry
post_Xgrid=function(thex,l,k,theXgrid_in,beta_in,eta_in,E_in,V_in,thenum)
{
 #Xgrid_in the X_grid_k[[k]]
 #update for thex (the current value), the lth in theXgrid_in
 newXgrid=theXgrid_in
 newXgrid[l]=thex
 theprob=mean((1+exp(-(beta_in[1]+beta_in[2]*newXgrid+eta_in[k])))^(-1))
 part1=Y[k]*log(theprob)+(N[k]-Y[k])*log(1-theprob)
 part2=(-1)*0.5*(thex-E_in[thenum])^2/V_in[thenum]
 res=part1+part2
 if(res==-Inf)
 {
  res=-9999999999999
 }
 if(res==Inf)
 {
  res=9999999999999
 }
 return(res)
}
update_Xgrid=function(Lk_in,X_L_in,X_grid_in,beta_in,eta_in,E_in,V_in,omega_in,acc_Xgrid_in)
{
  #update each X_grid[kl]
  #omega is the variance for proposal dist
  K=length(Lk)
  thenum=0
  for(k in 1:K)
  {
   theXset=X_grid_in[[k]]
   for(l in 1:Lk[k])
   {
    thenum=thenum+1
    #get proposal
    thecurr=theXset[l]
    thestar=rnorm(1,thecurr,omega_in[thenum])
    logA=post_Xgrid(thestar,l,k,theXset,beta_in,eta_in,E_in,V_in,thenum)
    logB=post_Xgrid(thecurr,l,k,theXset,beta_in,eta_in,E_in,V_in,thenum)
    logrr=logA-logB
    logu=log(runif(1,0,1))
    if(logrr>logu)
    {
     X_L_in[thenum]=thestar
     X_grid_in[[k]][l]=thestar
     acc_Xgrid_in[thenum]=acc_Xgrid_in[thenum]+1
    }
   }
  }
  return(list(X_L_in,X_grid_in,acc_Xgrid_in))
}
#######################################end of usefull functions

####################################################
#2.fit GP using observed exposures and predict X values
##(2.1)read in the site of exposures
site_coor=read.csv(paste(dir0,"site_coor.csv",sep=""),header=T)
####read in the exposures
X_obs=read.csv(paste(dir0,"X_obs.csv",sep=""),header=T)
X_obs=sqrt(X_obs[,1])
X_M=X_obs
M=length(X_obs)
I_M=rep(1,M)
dist_M=matrix(0,nrow=M,ncol=M)
for(i in 1:M)
{
 for(j in 1:M)
 {
  lat1=site_coor[i,1]
  lon1=site_coor[i,2]
  lat2=site_coor[j,1]
  lon2=site_coor[j,2]
  dist_M[i,j]=sqrt((lat1-lat2)^2+(lon1-lon2)^2)
 }
}

##(2.2)use the estimated (mu,sigma2,phi) to predict X for each person
######(2.2.1)read in the locations of each individual
N=read.csv(paste(dir0,"N.csv",sep=""),header=T)
N=N[,1]
K=length(N)
Nsum=sum(N)

##(2.3)use the estimated (mu,sigma2,phi) to predict X_grid using Kriging
######(2.3.1)read in the randomly selected locations for each region
grid_coor=read.csv(paste(dir0,"grid_coor.csv",sep=""),header=T)
Lk=read.csv(paste(dir0,"Lk.csv",sep=""),header=T)
Lk=Lk[,1]
L=sum(Lk)

X_cen=read.csv(paste(dir1,"X_cen.csv",sep=""),header=T)
X_cen=X_cen[,1]
X_grid=read.csv(paste(dir1,"X_grid.csv",sep=""),header=T)
X_grid=X_grid[,1]
X_cen=(X_cen-4.78)/0.2
X_grid=(X_grid-4.78)/0.2
##########################################end of GP

##########################################
#3.some more needed distance matrices
##(3.1)In PP, find a set of knots, using the centroids of each area
######(3.1.1)read in locations of centroids
city_coor=read.csv(paste(dir0,"county_coor.csv",sep=""),header=T)
colnames(city_coor)=c("LON","LAT")
J=dim(city_coor)[1]
######(3.1.2)get some dist matrix, coor_all is the collection of X_M and X_centroids
coor_all=rbind(site_coor,city_coor)
dist_all=matrix(0,nrow=(J+M),ncol=(J+M))
for(i in 1:(J+M))
{
 lat1=coor_all[i,1]
 lon1=coor_all[i,2]
 dist_all[i,]=sqrt((lat1-coor_all[,1])^2+(lon1-coor_all[,2])^2)
}
#using X_star to get X_L, we need locations of grids and get dist_J and dist_JL
dist_JL=matrix(0,nrow=J,ncol=L)
dist_J=matrix(0,nrow=J,ncol=J)
for(i in 1:J)
{
 lat1=city_coor[i,1]
 lon1=city_coor[i,2]
 dist_JL[i,]=sqrt((lat1-grid_coor[,1])^2+(lon1-grid_coor[,2])^2)
 dist_J[i,]=sqrt((lat1-city_coor[,1])^2+(lon1-city_coor[,2])^2)
}
######(3.1.3)used in PP
dist_MJ=matrix(0,nrow=M,ncol=J)
for(i in 1:M)
{
 for(j in 1:J)
 {
  lat1=site_coor[i,1]
  lon1=site_coor[i,2]
  lat2=city_coor[j,1]
  lon2=city_coor[j,2]
  dist_MJ[i,j]=sqrt((lat1-lat2)^2+(lon1-lon2)^2)
 }
}

##(3.2)some distance matrices, used in NNGP
#######find a reference set, using the centroids of each area
######(3.2.1)read in locations of centroids and locations of grids
######city_coor has already been read in
######grid info has already been read in
J=dim(city_coor)[1]
######the reference set now is X_M and X_R
R=J+M
A=R+L
######(3.2.2)find nearest neigbour for each location in grids, and the reference set
G=10
#since the reference set is the same with knots set, so the distance mat is dist_JL
coor_R=rbind(site_coor,city_coor)
colnames(grid_coor)=c("LON","LAT")
coor_A=rbind(coor_R,grid_coor)
dist_RA=matrix(0,nrow=R,ncol=A)
dist_R=matrix(0,nrow=R,ncol=R)
for(i in 1:R)
{
 lat1=coor_R[i,1]
 lon1=coor_R[i,2]
 dist_RA[i,]=sqrt((lat1-coor_A[,1])^2+(lon1-coor_A[,2])^2)
 dist_R[i,]=sqrt((lat1-coor_R[,1])^2+(lon1-coor_R[,2])^2)
}
sortdist=apply(dist_RA,2,order)
NNset=sortdist[2:(G+1),] #each column is for each grid

######(3.2.3)get some other dist matrix
########need two distance matrix:
########one is the distance between each entry and its NNset
########the other the distance between each entry in its NNset
dist_AN_sub=list()
dist_NN_sub=list()
for(l in 1:A)
{
 nnnum=NNset[,l]
 dist_AN_sub[[l]]=dist_RA[nnnum,l]
 dist_NN_sub[[l]]=dist_R[nnnum,nnnum]
}
##########################################end of defining matrices

##########################################
#4.read in N, prepare matrices for saving, generate Y
##(4.1)read in the N_k, i.e. the total number of visit in July 16,1995
b0=-3.1
b1=0.35
PP=2
W.mat=read.csv(paste(dir0,"W.mat.csv",sep=""),header=T)
W.mat=as.matrix(W.mat)
tau=0.1
eta_orig=read.csv(paste(dir1,"eta_orig.csv",sep=""),header=T)
eta_orig=eta_orig[,1]
#eta_orig=etagen(tau,W.mat,1000)

Y=read.csv(paste(dir0,"Y.csv",sep=""),header=T)
Y=Y[,1]

  ##########################################end of generating data
  ####################################
  #5.use the generated Y and X_M to fit out model,jointly,NNGP
  ##(5.1)fit model using NNGP
  ######(5.1.1)some global parameters
  n.T=4000
  n.burn0=100
  n.burn=0
  n.tune=100
  times=10 #times for tune sigma
  step=2 #save posterior every stepth,so the total number is (n.T-n.burn)/step
  saveT4=(n.T-n.burn)/step
  musave_n=rep(0,saveT4)
  sigma2save_n=rep(0,saveT4)
  phisave_n=rep(0,saveT4)
  etasave_n=matrix(0,nrow=saveT4,ncol=K)
  betasave_n=matrix(0,nrow=saveT4,ncol=PP)
  tausave_n=rep(0,saveT4)
  probsave_n=matrix(0,nrow=saveT4,ncol=K)
  smrsave_n=matrix(0,nrow=saveT4,ncol=K)
  Esave_n=matrix(0,nrow=saveT4,ncol=K)
  Atau=Btau=1
  Asigma2=3
  Bsigma2=0.5
  Cphi=0.05
  Dphi=1/100
  Ephi=5*15
  Fphi=1*15
  ######(5.1.2)initalize
  mu=0
  #sigma2=rigamma(1,Asigma2,Bsigma2)
  sigma2=0.1
  #phi=rgamma(1,shape=Ephi,rate=Fphi)
  phi=4.5
  #X_J=mvrnorm(J,0,1)[,1]
  X_J=X_cen
  X_R=c(X_M,X_J)
  #X_L=mvrnorm(L,0,1)[,1]
  X_L=X_grid
  X_L_k=list(0)
  tmp=0
  for(k in 1:K)
  {
   #find the index of X_grid in area k
   thenum=seq(tmp+1,tmp+Lk[k])
   tmp=tmp+Lk[k]
   X_L_k[[k]]=X_L[thenum]
  }
  X_A=c(X_R,X_L)
  H_A_vec=rep(0,A)
  B_A=matrix(0,nrow=A,ncol=R)
  for(a in 1:A)
  {
   theHa=exp(-phi*dist_AN_sub[[a]])
   thenn=solve(exp(-phi*dist_NN_sub[[a]]))
   nnnum=NNset[,a]
   H_A_vec[a]=(1-t(theHa)%*%thenn%*%theHa)[1,1]
   B_A[a,nnnum]=t(theHa)%*%thenn
  }
  #H_A_vec=mapply(function(x,y){1-t(exp(-phi*x))%*%(solve(exp(-phi*y)))%*%(exp(-phi*x))},dist_AN_sub,dist_NN_sub)
  #B_A2=mapply(function(x,y){t(exp(-phi*x))%*%(solve(exp(-phi*y)))},dist_AN_sub,dist_NN_sub)
  #aa=simplify2array(res, higher = TRUE)
  #Hs_A=diag(1/H_A_vec,A,A)
  #Vs_A=1/sigma2*Hs_A
  I_A=rep(1,A)
  I_R=rep(1,R)
  E_A=mu+B_A%*%(X_R-mu)
  P=M+L
  I_P=rep(1,P)
  X_P=c(X_M,X_L)
  eta=eta_orig
  #eta=eta[,1]
  #beta=rnorm(PP,0,1)
  beta=c(b0,b1)
  #tau=rgamma(1,Atau,Btau)
  tau=0.1
  omega_in_eta=rep(0.7,K)
  omega_in_beta=c(0.5,0.1)
  omega_in_Xgrid=rep(150,L)

  ######(5.2)start with burn-in
  acc_eta=rep(0,K)  #count for acceptance
  acc_beta=rep(0,PP)
  acc_phi=0
  acc_Xgrid=rep(0,L)
  beta2=beta1=rep(0,n.burn0)
  for(nn in 1:n.burn0)
  {
   ########update mu, norm(Eu,Vu)
   #part1=t(I_A-B_A%*%I_R)%*%Vs_A%*%(I_A-B_A%*%I_R)
   #Vu=solve(part1)[1,1]
   #part2=t(I_A-B_A%*%I_R)%*%Vs_A%*%(X_A-B_A%*%X_R)
   #Eu=Vu%*%(part2)[1,1]
   #mu=rnorm(1,Eu,sd=sqrt(Vu)) 
   ########update E_A
   #E_A=mu+B_A%*%(X_R-mu)
   ########update sigma2, IG(anew,bnew)
   anew=Asigma2+A/2
   part=(t(X_A-E_A)%*%Hs_A%*%(X_A-E_A))[1,1]
   part=sum(((X_A-E_A)^2)/H_A_vec)
   bnew=Bsigma2+0.5*(part)
   sigma2=rigamma(1,anew,bnew)
   ########update phi
   theres=update_phi2(phi,Cphi,Dphi,dist_AN_sub,dist_NN_sub,NNset,sigma2,mu,X_A,X_R,Ephi,Fphi,acc_phi)
   phi=theres[[1]]
   acc_phi=theres[[2]]
   ########with the updated phi,we should updata H_all
   H_A_vec=rep(0,A)
   B_A=matrix(0,nrow=A,ncol=R)
   for(a in 1:A)
   {
    nnnum=NNset[,a]
    theHa=exp(-phi*dist_AN_sub[[a]])
    thenn=solve(exp(-phi*dist_NN_sub[[a]]))
    theres=crossprod(theHa,thenn)
    B_A[a,nnnum]=theres
    H_A_vec[a]=(1-theres%*%theHa)[1,1]
   }
   #Hs_A=diag(1/H_A_vec,A,A)
   #Vs_A=1/sigma2*Hs_A
   E_A=mu+B_A%*%(X_R-mu)
   #split E_A,B_A,H_A_vec into two parts, one is for X_J, the other is for X_P
   H_P_vec=c(H_A_vec[1:M],H_A_vec[(R+1):A])
   H_J_vec=H_A_vec[(M+1):R]
   #Hs_P=diag(1/H_P_vec,P,P)
   #Hs_J=diag(1/H_J_vec,J,J)
   B_J=B_A[(M+1):R,]
   B_P=rbind(B_A[1:M,],B_A[(R+1):A,])
   B_J1=B_J[,1:M]
   B_J2=B_J[,(M+1):R]
   B_P1=B_P[,1:M]
   B_P2=B_P[,(M+1):R]
   the1=B_P2/sqrt(H_P_vec)
   res1=crossprod(the1,the1)
   the2=diag(rep(1,J))-2*B_J2
   res2=the2/H_J_vec
   the3=B_J2/sqrt(H_J_vec)
   res3=crossprod(the3,the3)
   theH=solve(res3+res2+res1)
   theV=sigma2*theH
   the0=X_P-mu-apply(t(B_P1)*X_M,2,sum)+mu*apply(B_P,1,sum)
   the1=the0/H_P_vec
   part1=apply(B_P2*the1,2,sum)
   #part1=t(B_P2)%*%Hs_P%*%(X_P-mu-B_P1%*%X_M+mu*B_P%*%I_R)
   part=mu+apply(t(B_J1)*X_M,2,sum)-mu*apply(B_J,1,sum)
   part2=apply(B_J2*part/H_J_vec,2,sum)
   part3=part/H_J_vec
   theE=(theH%*%(part1-part2+part3))[,1]
   ########update X_R, norm(theE,theV)
   X_J=mvrnorm(1,theE,theV) 
   ########update using X_R
   X_R=c(X_M,X_J)
   ########update X_L and X_grid_k using MH
   E_L=E_A[(R+1):A,1]
   H_L_vec=H_A_vec[(R+1):A]
   V_L_vec=sigma2*H_L_vec
   theres=update_Xgrid(Lk,X_L,X_L_k,beta,eta,E_L,V_L_vec,omega_in_Xgrid,acc_Xgrid)
   X_L=theres[[1]]
   X_L_k=theres[[2]]
   acc_Xgrid=theres[[3]]
   ########update using X_L
   X_A=c(X_R,X_L)
   X_P=c(X_M,X_L)
   ########update each eta using MH
   theres=update_eta(W.mat,eta,beta,X_L_k,tau,omega_in_eta,acc_eta,4)
   eta=theres[[1]]
   acc_eta=theres[[2]]
   ########update each beta using M-H
   theres=update_beta(eta,beta,X_L_k,omega_in_beta,acc_beta,4)
   beta=theres[[1]]
   beta2[nn]=beta[2]
   beta1[nn]=beta[1]
   acc_beta=theres[[2]]
   ########update tau
   tau=update_tau(eta,Atau,Btau,W.mat)
  }
   acc_eta=acc_eta/n.burn0
   acc_beta=acc_beta/n.burn0
   acc_phi=acc_phi/n.burn0
   acc_Xgrid=acc_Xgrid/n.burn0
   #acc_eta
   print(acc_beta)
   #acc_phi
   print(summary(acc_Xgrid))
   print(summary(beta2))
   print(summary(beta1))
   if(mean(acc_Xgrid)>0.2)
   {
    omega_in_Xgrid=rep(100,L)
   }
  ######(5.3)model fitting
  acc_eta=rep(0,K)  #count for acceptance
  acc_beta=rep(0,PP)
  acc_phi=0
  acc_Xgrid=rep(0,L)
  beta1=beta2=rep(0,n.T)
  for(nn in 1:n.T)
  {
   ########update mu, norm(Eu,Vu)
   #part1=t(I_A-B_A%*%I_R)%*%Vs_A%*%(I_A-B_A%*%I_R)
   #Vu=solve(part1)[1,1]
   #part2=t(I_A-B_A%*%I_R)%*%Vs_A%*%(X_A-B_A%*%X_R)
   #Eu=Vu%*%(part2)[1,1]
   #mu=rnorm(1,Eu,sd=sqrt(Vu)) 
   ########update E_A
   #E_A=mu+B_A%*%(X_R-mu)
   ########update sigma2, IG(anew,bnew)
   anew=Asigma2+A/2
   #part=(t(X_A-E_A)%*%Hs_A%*%(X_A-E_A))[1,1]
   part=sum(((X_A-E_A)^2)/H_A_vec)
   bnew=Bsigma2+0.5*(part)
   sigma2=rigamma(1,anew,bnew)
   ########update phi
   theres=update_phi2(phi,Cphi,Dphi,dist_AN_sub,dist_NN_sub,NNset,sigma2,mu,X_A,X_R,Ephi,Fphi,acc_phi)
   phi=theres[[1]]
   acc_phi=theres[[2]]
   ########with the updated phi,we should updata H_all
   H_A_vec=rep(0,A)
   B_A=matrix(0,nrow=A,ncol=R)
   for(a in 1:A)
   {
    nnnum=NNset[,a]
    theHa=exp(-phi*dist_AN_sub[[a]])
    thenn=solve(exp(-phi*dist_NN_sub[[a]]))
    theres=crossprod(theHa,thenn)
    B_A[a,nnnum]=theres
    H_A_vec[a]=(1-theres%*%theHa)[1,1]
   }
   #Hs_A=diag(1/H_A_vec,A,A)
   #Vs_A=1/sigma2*Hs_A
   E_A=mu+B_A%*%(X_R-mu)
   #split E_A,B_A,H_A_vec into two parts, one is for X_J, the other is for X_P
   H_P_vec=c(H_A_vec[1:M],H_A_vec[(R+1):A])
   H_J_vec=H_A_vec[(M+1):R]
   #Hs_P=diag(1/H_P_vec,P,P)
   #Hs_J=diag(1/H_J_vec,J,J)
   B_J=B_A[(M+1):R,]
   B_P=rbind(B_A[1:M,],B_A[(R+1):A,])
   B_J1=B_J[,1:M]
   B_J2=B_J[,(M+1):R]
   B_P1=B_P[,1:M]
   B_P2=B_P[,(M+1):R]
   the1=B_P2/sqrt(H_P_vec)
   res1=crossprod(the1,the1)
   the2=diag(rep(1,J))-2*B_J2
   res2=the2/H_J_vec
   the3=B_J2/sqrt(H_J_vec)
   res3=crossprod(the3,the3)
   theH=solve(res3+res2+res1)
   theV=sigma2*theH
   the0=X_P-mu-apply(t(B_P1)*X_M,2,sum)+mu*apply(B_P,1,sum)
   the1=the0/H_P_vec
   part1=apply(B_P2*the1,2,sum)
   #part1=t(B_P2)%*%Hs_P%*%(X_P-mu-B_P1%*%X_M+mu*B_P%*%I_R)
   part=mu+apply(t(B_J1)*X_M,2,sum)-mu*apply(B_J,1,sum)
   part2=apply(B_J2*part/H_J_vec,2,sum)
   part3=part/H_J_vec
   theE=(theH%*%(part1-part2+part3))[,1]
   ########update X_R, norm(theE,theV)
   X_J=mvrnorm(1,theE,theV) 
   ########update using X_R
   X_R=c(X_M,X_J)
   ########update X_L and X_grid_k using MH
   E_L=E_A[(R+1):A,1]
   H_L_vec=H_A_vec[(R+1):A]
   V_L_vec=sigma2*H_L_vec
   theres=update_Xgrid(Lk,X_L,X_L_k,beta,eta,E_L,V_L_vec,omega_in_Xgrid,acc_Xgrid)
   X_L=theres[[1]]
   X_L_k=theres[[2]]
   acc_Xgrid=theres[[3]]
   ########update using X_L
   X_A=c(X_R,X_L)
   X_P=c(X_M,X_L)
   ########update each eta using MH
   theres=update_eta(W.mat,eta,beta,X_L_k,tau,omega_in_eta,acc_eta,4)
   eta=theres[[1]]
   acc_eta=theres[[2]]
   ########update each beta using M-H
   theres=update_beta(eta,beta,X_L_k,omega_in_beta,acc_beta,4)
   beta=theres[[1]]
   beta2[nn]=beta[2]
   beta1[nn]=beta[1]
   acc_beta=theres[[2]]
   ########update tau
   tau=update_tau(eta,Atau,Btau,W.mat)
   ########save posteriors after burnin
   if((nn>n.burn)&((nn-n.burn)%%step==0))
   {
    #musave_n[(nn-n.burn)/step]=mu
    sigma2save_n[(nn-n.burn)/step]=sigma2
    phisave_n[(nn-n.burn)/step]=phi
    etasave_n[(nn-n.burn)/step,]=eta
    betasave_n[(nn-n.burn)/step,]=beta
    tausave_n[(nn-n.burn)/step]=tau
    p=rep(0,K)
    for(k in 1:K)
    {
     p[k]=mean((1+exp(-(beta[1]+beta[2]*X_L_k[[k]]+eta[k])))^(-1))
    }
    bb=sum(N*p)/sum(N)
    probsave_n[(nn-n.burn)/step,]=p
    smrsave_n[(nn-n.burn)/step,]=p/bb
    Esave_n[(nn-n.burn)/step,]=N*bb 
   }
  }
   acc_eta=acc_eta/n.T
   acc_beta=acc_beta/n.T
   acc_phi=acc_phi/n.T
   acc_Xgrid=acc_Xgrid/n.T
   ####################################end for fit model with NNGP

  ######################################
  #6.after model fitting, get saved values
  write.csv(sigma2save_n,paste(dir,"sigma2save_n.csv",sep=""),row.names=F)
  write.csv(phisave_n,paste(dir,"phisave_n.csv",sep=""),row.names=F)
  write.csv(etasave_n,paste(dir,"etasave_n.csv",sep=""),row.names=F)
  write.csv(betasave_n,paste(dir,"betasave_n.csv",sep=""),row.names=F)
  write.csv(tausave_n,paste(dir,"tausave_n.csv",sep=""),row.names=F)
  write.csv(probsave_n,paste(dir,"probsave_n.csv",sep=""),row.names=F)
  write.csv(smrsave_n,paste(dir,"smrsave_n.csv",sep=""),row.names=F)
  write.csv(Esave_n,paste(dir,"Esave_n.csv",sep=""),row.names=F)

  beta_n_each_mean=apply(betasave_n,2,mean)
  beta_n_each_med=apply(betasave_n,2,median)
  beta_n_each_sd=apply(betasave_n,2,sd)
  beta_n_each_lower=apply(betasave_n,2,function(x){return(quantile(x,0.025))})
  beta_n_each_upper=apply(betasave_n,2,function(x){return(quantile(x,0.975))})
  beta_save_n=cbind(beta_n_each_mean,beta_n_each_med,beta_n_each_sd,beta_n_each_lower,beta_n_each_upper)
  write.csv(beta_save_n,paste(dir,"beta_save_n.csv",sep=""),row.names=F) 
  prob_n_each_mean=apply(probsave_n,2,mean)
  prob_n_each_med=apply(probsave_n,2,median)
  prob_n_each_sd=apply(probsave_n,2,sd)
  prob_n_each_lower=apply(probsave_n,2,function(x){return(quantile(x,0.025))})
  prob_n_each_upper=apply(probsave_n,2,function(x){return(quantile(x,0.975))})
  prob_save_n=cbind(prob_n_each_mean,prob_n_each_med,prob_n_each_sd,prob_n_each_lower,prob_n_each_upper)
  write.csv(prob_save_n,paste(dir,"prob_save_n.csv",sep=""),row.names=F) 
  smr_n_each_mean=apply(smrsave_n,2,mean)
  smr_n_each_med=apply(smrsave_n,2,median)
  smr_n_each_sd=apply(smrsave_n,2,sd)
  smr_n_each_lower=apply(smrsave_n,2,function(x){return(quantile(x,0.025))})
  smr_n_each_upper=apply(smrsave_n,2,function(x){return(quantile(x,0.975))})
  smr_save_n=cbind(smr_n_each_mean,smr_n_each_med,smr_n_each_sd,smr_n_each_lower,smr_n_each_upper)
  write.csv(smr_save_n,paste(dir,"smr_save_n.csv",sep=""),row.names=F) 
