#fit our proposed model using the fully Bayesian approach with predictive process
rm(list=ls(all=TRUE))

dir0="C:/eco fal/"
dir1="C:/eco fal/GP_results/"
dir="C:/eco fal/results/"

library(pscl)

###################################################
#1. some useful functions
##(1.1)update phi in GP, PP
post_phi=function(star,phi_in,c_in,d_in,dist_in,sigma2_in,mu_in,X_in,e_in,f_in)
{
 H1=exp(-star*dist_in)
 Hs1=solve(H1)
 H2=exp(-phi_in*dist_in)
 Hs2=solve(H2)
 #Hs_in is the inverse of H
 part11=(c_in-1)*log(star)-d_in*star
 part12=(c_in-1)*log(phi_in)-d_in*phi_in
 d1=det(Hs1)
 if(d1==Inf)
 {
  d1=1000000000
 }
 d2=det(Hs2)
  if(d2==Inf)
 {
  d2=1000000000
 }
 part2=0.5*(log(d1/d2))
 part31=(-0.5)/sigma2_in*(t(X_in-mu_in)%*%Hs1%*%(X_in-mu_in))[1,1]
 part32=(-0.5)/sigma2_in*(t(X_in-mu_in)%*%Hs2%*%(X_in-mu_in))[1,1]
 part41=(e_in-1)*log(star)-f_in*star
 part42=(e_in-1)*log(phi_in)-f_in*phi_in
 res=part11-part12+part2+part31-part32-part41+part42
 return(res)
}
update_phi=function(phi_in,c_in,d_in,dist_in,sigma2_in,mu_in,X_in,e_in,f_in,acc_phi_in)
{
  #get proposal
  thestar=0
  while(thestar<0.00001)
  {
   thestar=rgamma(1,shape=e_in,rate=f_in)
  }
  logrr=post_phi(thestar,phi_in,c_in,d_in,dist_in,sigma2_in,mu_in,X_in,e_in,f_in)
  logu=log(runif(1,0,1))
  if(logrr>logu)
  {
   phi_in=thestar
   acc_phi_in=acc_phi_in+1
  }
  return(list(phi_in,acc_phi_in))
}

##(1.2)update eta
post_eta=function(theeta,k,W,eta_in,beta_in,X_in,tau_in,index)
{
 #theeta is the current value of eta[k], k the index of eta
 #if index=1, then X_in[k] is a number
 #if index>1, then X_in[[k]] is a vector, the grids in region k
 thesum=sum(W[k,])
 etabar=((W[k,]%*%eta_in)/thesum)[1,1]
 if(index==1)
 {
  theprob=(1+exp(-(beta_in[1]+beta_in[2]*X_in[k]+theeta)))^(-1)
 }
 if(index>1)
 {
  theprob=mean((1+exp(-(beta_in[1]+beta_in[2]*X_in[[k]]+theeta)))^(-1))
 }
 part1=0.5*tau_in*thesum*(theeta-etabar)^2
 part2=Y[k]*log(theprob)
 part3=(N[k]-Y[k])*log(1-theprob)
 res=part1*(-1)+part2+part3
 return(res)
}
update_eta=function(W,eta_in,beta_in,X_in,tau_in,omega_in,acc_eta_in,index)
{
  #update each eta[i]
  #omega is the variance for proposal dist
  for(k in 1:K)
  {
   #get proposal
   thecurr=eta_in[k]
   thestar=rnorm(1,thecurr,omega_in[k])
   logA=post_eta(thestar,k,W,eta_in,beta_in,X_in,tau_in,index)
   logB=post_eta(thecurr,k,W,eta_in,beta_in,X_in,tau_in,index)
   logrr=logA-logB
   logu=log(runif(1,0,1))
   if(logrr>logu)
   {
    eta_in[k]=thestar
    acc_eta_in[k]=acc_eta_in[k]+1
   }
  }
  #then centering eta
  eta_in=eta_in-mean(eta_in)
  return(list(eta_in,acc_eta_in))
}

post_eta1=function(star,curr,k,W,eta_in,beta_in,X_in,tau_in,index)
{
  #theeta is the current value of eta[k], k the index of eta
  #if index=1, then X_in[k] is a number
  #if index>1, then X_in[[k]] is a vector, the grids in region k
  thesum=sum(W[k,])
  etabar=((W[k,]%*%eta_in)/thesum)[1,1]
  if(index==1)
  {
    theprob1=(1+exp(-(beta_in[1]+beta_in[2]*X_in[k]+star)))^(-1)
    theprob2=(1+exp(-(beta_in[1]+beta_in[2]*X_in[k]+curr)))^(-1)
  }
  if(index>1)
  {
    theprob1=mean((1+exp(-(beta_in[1]+beta_in[2]*X_in[[k]]+star)))^(-1))
    theprob2=mean((1+exp(-(beta_in[1]+beta_in[2]*X_in[[k]]+curr)))^(-1))
    if(theprob1==1)
    {theprob1=theprob1-0.000001}
    if(theprob2==1)
    {theprob2=theprob2-0.000001}
    if(theprob1==0)
    {theprob1=theprob1+0.000001}
    if(theprob2==0)
    {theprob2=theprob2+0.000001}
  }

  part1=0.5*tau_in*thesum*(star-etabar)^2
  part11=0.5*tau_in*thesum*(curr-etabar)^2
  part2=Y[k]*log(theprob1/theprob2)
  part3=(N[k]-Y[k])*log((1-theprob1)/(1-theprob2))
  res=(part1-part11)*(-1)+part2+part3
  return(res)
}
update_eta1=function(W,eta_in,beta_in,X_in,tau_in,omega_in,acc_eta_in,index)
{
  #update each eta[i]
  #omega is the variance for proposal dist
  for(k in 1:K)
  {
    #get proposal
    thecurr=eta_in[k]
    thestar=rnorm(1,thecurr,omega_in[k])
    logrr=post_eta1(thestar,thecurr,k,W,eta_in,beta_in,X_in,tau_in,index)
    logu=log(runif(1,0,1))
    if(logrr>logu)
    {
      eta_in[k]=thestar
      acc_eta_in[k]=acc_eta_in[k]+1
    }
  }
  #then centering eta
  eta_in=eta_in-mean(eta_in)
  return(list(eta_in,acc_eta_in))
}

##(1.3)update beta
post_beta=function(thebeta,i,eta_in,beta_in,X_in,index)
{
 #thebeta is the current value of beta[i], i the index of beta
 newbeta=beta_in
 newbeta[i]=thebeta
 if(index==1)
 {
  probmat=(1+exp(-(newbeta[1]+newbeta[2]*X_in+eta_in)))^(-1)
 }
 if(index>1)
 {
  probmat=rep(0,K)
  for(k in 1:K)
  {
   probmat[k]=mean((1+exp(-(newbeta[1]+newbeta[2]*X_in[[k]]+eta_in[k])))^(-1))
  }
 }
 a=Y*log(probmat)
 b=(N-Y)*log(1-probmat)
 part1=sum(a)
 part2=sum(b)
 res=part1+part2
 return(res)
}
update_beta=function(eta_in,beta_in,X_in,omega_in,acc_beta_in,index)
{
  #update each beta[i]
  #omega is the variance for proposal dist
  P=length(beta_in)
  for(i in 1:P)
  {
   #get proposal
   thecurr=beta_in[i]
   thestar=rnorm(1,thecurr,omega_in[i])
   logA=post_beta(thestar,i,eta_in,beta_in,X_in,index)
   logB=post_beta(thecurr,i,eta_in,beta_in,X_in,index)
   logrr=logA-logB
   logu=log(runif(1,0,1))
   if(logrr>logu)
   {
    beta_in[i]=thestar
    acc_beta_in[i]=acc_beta_in[i]+1
   }
  }
  return(list(beta_in,acc_beta_in))
}

post_beta1=function(star,curr,i,eta_in,beta_in,X_in,index)
{
  #thebeta is the current value of beta[i], i the index of beta
  newbeta1=newbeta2=beta_in
  newbeta1[i]=star
  newbeta2[i]=curr
  if(index==1)
  {
    probmat1=(1+exp(-(newbeta1[1]+newbeta1[2]*X_in+eta_in)))^(-1)
    probmat2=(1+exp(-(newbeta2[1]+newbeta2[2]*X_in+eta_in)))^(-1)
  }
  if(index>1)
  {
    probmat1=probmat2=rep(0,K)
    for(k in 1:K)
    {
      probmat1[k]=mean((1+exp(-(newbeta1[1]+newbeta1[2]*X_in[[k]]+eta_in[k])))^(-1))
      probmat2[k]=mean((1+exp(-(newbeta2[1]+newbeta2[2]*X_in[[k]]+eta_in[k])))^(-1))
    }
    num1=which(probmat1==1)
    probmat1[num1]=probmat1[num1]-0.0000001
    num2=which(probmat2==1)
    probmat2[num2]=probmat2[num2]-0.0000001
    num1=which(probmat1==0)
    probmat1[num1]=probmat1[num1]+0.0000001
    num2=which(probmat2==0)
    probmat2[num2]=probmat2[num2]+0.0000001
  }
  a=Y*log(probmat1/probmat2)
  b=(N-Y)*log((1-probmat1)/(1-probmat2))
  part1=sum(a)
  part2=sum(b)
  res=part1+part2
  return(res)
}
update_beta1=function(eta_in,beta_in,X_in,omega_in,acc_beta_in,index)
{
  #update each beta[i]
  #omega is the variance for proposal dist
  P=length(beta_in)
  for(i in 1:P)
  {
    #get proposal
    thecurr=beta_in[i]
    thestar=rnorm(1,thecurr,omega_in[i])
    logrr=post_beta1(thestar,thecurr,i,eta_in,beta_in,X_in,index)
    logu=log(runif(1,0,1))
    if(logrr>logu)
    {
      beta_in[i]=thestar
      acc_beta_in[i]=acc_beta_in[i]+1
    }
  }
  return(list(beta_in,acc_beta_in))
}

post_beta2=function(star,eta_in,beta_in,X_in,index)
{
  #thebeta is the current value of beta[i], i the index of beta
  newbeta1=star
  newbeta2=beta_in
  if(index==1)
  {
    probmat1=(1+exp(-(newbeta1[1]+newbeta1[2]*X_in+eta_in)))^(-1)
    probmat2=(1+exp(-(newbeta2[1]+newbeta2[2]*X_in+eta_in)))^(-1)
  }
  if(index>1)
  {
    probmat1=probmat2=rep(0,K)
    for(k in 1:K)
    {
      probmat1[k]=mean((1+exp(-(newbeta1[1]+newbeta1[2]*X_in[[k]]+eta_in[k])))^(-1))
      probmat2[k]=mean((1+exp(-(newbeta2[1]+newbeta2[2]*X_in[[k]]+eta_in[k])))^(-1))
    }
    num1=which(probmat1==1)
    probmat1[num1]=probmat1[num1]-0.0000001
    num2=which(probmat2==1)
    probmat2[num2]=probmat2[num2]-0.0000001
    num1=which(probmat1==0)
    probmat1[num1]=probmat1[num1]+0.0000001
    num2=which(probmat2==0)
    probmat2[num2]=probmat2[num2]+0.0000001
  }
  a=Y*log(probmat1/probmat2)
  b=(N-Y)*log((1-probmat1)/(1-probmat2))
  part1=sum(a)
  part2=sum(b)
  res=part1+part2
  return(res)
}
update_beta2=function(eta_in,beta_in,X_in,omega_in,acc_beta_in,index)
{
  #update each beta[i]
  #omega is the variance for proposal dist
  P=length(beta_in)
  star=rep(0,P)
  for(i in 1:P)
  {
    #get proposal
    thecurr=beta_in[i]
    star[i]=rnorm(1,thecurr,omega_in[i])
  }
  logrr=post_beta2(star,eta_in,beta_in,X_in,index)
  logu=log(runif(1,0,1))
  if(logrr>logu)
  {
    beta_in=star
    acc_beta_in=acc_beta_in+1
  }
  return(list(beta_in,acc_beta_in))
}


##(1.4)to update tau
update_tau=function(eta_in,a,b,W)
{
  #calculte(eta_i-eta_j)^2
  K=length(eta_in)
  etalist=rep(eta_in,K)
  p1=matrix(etalist,nrow=K,ncol=K,byrow=T)
  p2=matrix(etalist,nrow=K,ncol=K,byrow=F)
  pp=(p1-p2)^2
  ppp=pp[lower.tri(pp)]
  www=W[lower.tri(W)]
  newb=b+sum(ppp*www)/2
  newa=a+K/2
  newtau=rgamma(1,newa,newb)
  return(newtau)
}

##(1.5)updata X_star, for each entry
post_Xstar1=function(thex,j,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in)
{
 #Xs_in the X_star
 #update for thex (the current value), the kth in X_star
 #matr1_in=t(H_JL_in)%*%Hs_J_in
 #matr2_in=t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])
 #matr3_in=sigma2*(1-t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])%*%H_J_sub[[j]])
 newXs=Xs_in
 newXs[j]=thex
 X_L=mu_in+matr1_in%*%(newXs-mu_in)
 K=length(eta_in)
 probmat=rep(0,K)
 tmp=0
 for(k in 1:K)
 {
  #find the index of X_grid in area k
  thenum=seq(tmp+1,tmp+Lk_in[k])
  tmp=tmp+Lk_in[k]
  X_k=(X_L[thenum])
  probmat[k]=mean((1+exp(-(beta_in[1]+beta_in[2]*X_k+eta_in[k])))^(-1))
 }
 a=Y*log(probmat)
 b=(N-Y)*log(1-probmat)
 part1=sum(a)
 part2=sum(b)
 #part3 is the conditional dist. of thex
 subX=c(X_M_in,newXs[-j])
 theE=mu_in+matr2_in[[j]]%*%(subX-mu_in)
 theV=matr3_in[[j]]
 part3=(-1)*0.5*(thex-theE)^2/theV
 res=part1+part2+part3
 return(res[1,1])
}
update_Xstar1=function(Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in,omega_in,acc_Xs_in)
{
  #update each X_star[j]
  #omega is the variance for proposal dist
  J=length(Xs_in)
  for(j in 1:J)
  {
   #get proposal
   thecurr=Xs_in[j]
   thestar=rnorm(1,thecurr,omega_in[j])
   logA=post_Xstar1(thestar,j,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in)
   logB=post_Xstar1(thecurr,j,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in)
   logrr=logA-logB
   logu=log(runif(1,0,1))
   if(logrr>logu)
   {
     Xs_in[j]=thestar
     acc_Xs_in[j]=acc_Xs_in[j]+1
   }
  }
   return(list(Xs_in,acc_Xs_in))
}

post_Xstar2=function(star,curr,j,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in)
{
  #Xs_in the X_star
  #update for thex (the current value), the kth in X_star
  #matr1_in=t(H_JL_in)%*%Hs_J_in
  #matr2_in=t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])
  #matr3_in=sigma2*(1-t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])%*%H_J_sub[[j]])
  newXs1=newXs2=Xs_in
  newXs1[j]=star
  newXs2[j]=curr
  X_L1=mu_in+matr1_in%*%(newXs1-mu_in)
  X_L2=mu_in+matr1_in%*%(newXs2-mu_in)
  K=length(eta_in)
  probmat1=probmat2=rep(0,K)
  tmp=0
  for(k in 1:K)
  {
    #find the index of X_grid in area k
    thenum=seq(tmp+1,tmp+Lk_in[k])
    tmp=tmp+Lk_in[k]
    X_k1=(X_L1[thenum])
    X_k2=(X_L2[thenum])
    probmat1[k]=mean((1+exp(-(beta_in[1]+beta_in[2]*X_k1+eta_in[k])))^(-1))
    probmat2[k]=mean((1+exp(-(beta_in[1]+beta_in[2]*X_k2+eta_in[k])))^(-1))
  }
  num1=which(probmat1==1)
  probmat1[num1]=probmat1[num1]-0.0000001
  num2=which(probmat2==1)
  probmat2[num2]=probmat2[num2]-0.0000001
  num1=which(probmat1==0)
  probmat1[num1]=probmat1[num1]+0.0000001
  num2=which(probmat2==0)
  probmat2[num2]=probmat2[num2]+0.0000001
  a=Y*log(probmat1/probmat2)
  b=(N-Y)*log((1-probmat1)/(1-probmat2))
  part1=sum(a)
  part2=sum(b)
  #part3 is the conditional dist. of thex
  subX=c(X_M_in,newXs1[-j])
  theE=mu_in+matr2_in[[j]]%*%(subX-mu_in)
  theV=matr3_in[[j]]
  part3=(-1)*0.5*(star-theE)^2/theV
  part33=(-1)*0.5*(curr-theE)^2/theV
  res=part1+part2+part3-part33
  return(res[1,1])
}
update_Xstar2=function(Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in,omega_in,acc_Xs_in)
{
  #update each X_star[j]
  #omega is the variance for proposal dist
  J=length(Xs_in)
  for(j in 1:J)
  {
    #get proposal
    thecurr=Xs_in[j]
    thestar=rnorm(1,thecurr,omega_in[j])
    logrr=post_Xstar2(thestar,thecurr,j,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,matr2_in,matr3_in)
    logu=log(runif(1,0,1))
    if(logrr>logu)
    {
      Xs_in[j]=thestar
      acc_Xs_in[j]=acc_Xs_in[j]+1
    }
  }
  return(list(Xs_in,acc_Xs_in))
}
post_Xstar3=function(star,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,E_in,Vs_in)
{
  #Xs_in the X_star
  #update for thex (the current value), the kth in X_star
  #matr1_in=t(H_JL_in)%*%Hs_J_in
  #matr2_in=t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])
  #matr3_in=sigma2*(1-t(H_J_sub[[j]])%*%slove(H_all_sub[[j]])%*%H_J_sub[[j]])
  newXs1=star
  newXs2=Xs_in
  X_L1=mu_in+matr1_in%*%(newXs1-mu_in)
  X_L2=mu_in+matr1_in%*%(newXs2-mu_in)
  K=length(eta_in)
  probmat1=probmat2=rep(0,K)
  tmp=0
  for(k in 1:K)
  {
    #find the index of X_grid in area k
    thenum=seq(tmp+1,tmp+Lk_in[k])
    tmp=tmp+Lk_in[k]
    X_k1=(X_L1[thenum])
    X_k2=(X_L2[thenum])
    probmat1[k]=mean((1+exp(-(beta_in[1]+beta_in[2]*X_k1+eta_in[k])))^(-1))
    probmat2[k]=mean((1+exp(-(beta_in[1]+beta_in[2]*X_k2+eta_in[k])))^(-1))
  }
  num1=which(probmat1==1)
  probmat1[num1]=probmat1[num1]-0.0000001
  num2=which(probmat2==1)
  probmat2[num2]=probmat2[num2]-0.0000001
  num1=which(probmat1==0)
  probmat1[num1]=probmat1[num1]+0.0000001
  num2=which(probmat2==0)
  probmat2[num2]=probmat2[num2]+0.0000001
  a=Y*log(probmat1/probmat2)
  b=(N-Y)*log((1-probmat1)/(1-probmat2))
  part1=sum(a)
  part2=sum(b)
  #part3 is the conditional dist. of thex
  part3=(-1)*0.5*t(newXs1-E_in)%*%Vs_in%*%(newXs1-E_in)
  part33=(-1)*0.5*t(newXs2-E_in)%*%Vs_in%*%(newXs2-E_in)
  res=part1+part2+part3-part33
  return(res[1,1])
}
update_Xstar3=function(Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,E_in,Vs_in,omega_in,acc_Xs_in)
{
  #update each X_star[j]
  #omega is the variance for proposal dist
  J=length(Xs_in)
  star=rep(0,J)
  for(j in 1:J)
  {
    #get proposal
    thecurr=Xs_in[j]
    star[j]=rnorm(1,thecurr,omega_in[j])
  }
  logrr=post_Xstar3(star,Xs_in,X_M_in,beta_in,eta_in,matr1_in,Lk_in,mu_in,E_in,Vs_in)
  logu=log(runif(1,0,1))
  if(logrr>logu)
  {
    Xs_in=star
    acc_Xs_in=acc_Xs_in+1
  }
  return(list(Xs_in,acc_Xs_in))
}
#######################################end of usefull functions

####################################################
#2.fit GP using observed exposures and predict X values
##(2.1)read in the site of exposures
site_coor=read.csv(paste(dir0,"site_coor.csv",sep=""),header=T)
####read in the exposures in 1995
X_obs=read.csv(paste(dir0,"X_obs.csv",sep=""),header=T)
X_obs=sqrt(X_obs[,1])
X_M=X_obs
M=length(X_obs)
I_M=rep(1,M)
dist_M=matrix(0,nrow=M,ncol=M)
for(i in 1:M)
{
 for(j in 1:M)
 {
  lat1=site_coor[i,1]
  lon1=site_coor[i,2]
  lat2=site_coor[j,1]
  lon2=site_coor[j,2]
  dist_M[i,j]=sqrt((lat1-lat2)^2+(lon1-lon2)^2)
 }
}

##(2.2)use the estimated (mu,sigma2,phi) to predict X for each person
######(2.2.1)read in the locations of each individual
N=read.csv(paste(dir0,"N.csv",sep=""),header=T)
N=N[,1]
K=length(N)
Nsum=sum(N)

##(2.3)use the estimated (mu,sigma2,phi) to predict X_grid using Kriging
######(2.3.1)read in the randomly selected locations for each region
grid_coor=read.csv(paste(dir0,"grid_coor.csv",sep=""),header=T)
Lk=read.csv(paste(dir0,"Lk.csv",sep=""),header=T)
Lk=Lk[,1]
L=sum(Lk)

X_area=read.csv(paste(dir1,"X_area.csv",sep=""),header=T)
X_area=X_area[,1]
X_grid=read.csv(paste(dir1,"X_grid.csv",sep=""),header=T)
X_grid=X_grid[,1]
X_area=(X_area-4.78)/0.2
X_grid=(X_grid-4.78)/0.2
X_cen=read.csv(paste(dir1,"X_cen.csv",sep=""),header=T)
X_cen=X_cen[,1]
X_cen=(X_cen-4.78)/0.2
##########################################end of GP

##########################################
#3.some more needed distance matrices
##(3.1)In PP, find a set of knots, using the centroids of each area
######(3.1.1)read in locations of centroids
city_coor=read.csv(paste(dir0,"county_coor.csv",sep=""),header=T)
J=dim(city_coor)[1]
colnames(city_coor)=c("LON","LAT")
######(3.1.2)get some dist matrix, coor_all is the collection of X_M and X_centroids
coor_all=rbind(site_coor,city_coor)
dist_all=matrix(0,nrow=(J+M),ncol=(J+M))
for(i in 1:(J+M))
{
 lat1=coor_all[i,1]
 lon1=coor_all[i,2]
 dist_all[i,]=sqrt((lat1-coor_all[,1])^2+(lon1-coor_all[,2])^2)
}
#using X_star to get X_L, we need locations of grids and get dist_J and dist_JL
dist_JL=matrix(0,nrow=J,ncol=L)
dist_J=matrix(0,nrow=J,ncol=J)
for(i in 1:J)
{
 lat1=city_coor[i,1]
 lon1=city_coor[i,2]
 dist_JL[i,]=sqrt((lat1-grid_coor[,1])^2+(lon1-grid_coor[,2])^2)
 dist_J[i,]=sqrt((lat1-city_coor[,1])^2+(lon1-city_coor[,2])^2)
}
######(3.1.3)if we update X_star one by one, we need some submatrix from dist_all
#every entry in dist_all_sub is dist_(all,-j),j
#every entry in dist_J_sub is dist_(all,-j),(all,-j)
dist_all_sub=list(0)
dist_J_sub=list(0)
for(j in 1:J)
{
 a=dist_all[j,]
 dist_J_sub[[j]]=a[-j]
 a=dist_all[-j,]
 dist_all_sub[[j]]=a[,-j]
}

dist_MJ=matrix(0,nrow=M,ncol=J)
for(i in 1:M)
{
 for(j in 1:J)
 {
  lat1=site_coor[i,1]
  lon1=site_coor[i,2]
  lat2=city_coor[j,1]
  lon2=city_coor[j,2]
  dist_MJ[i,j]=sqrt((lat1-lat2)^2+(lon1-lon2)^2)
 }
}
##########################################end of defining matrices

##########################################
#4.read in N, prepare matrices for saving, generate Y
b0=-3.1
b1=0.35
P=2
W.mat=read.csv(paste(dir0,"W.mat.csv",sep=""),header=T)
W.mat=as.matrix(W.mat)
tau=0.1
eta_orig=read.csv(paste(dir1,"eta_orig.csv",sep=""),header=T)
eta_orig=eta_orig[,1]
Y=read.csv(paste(dir0,"Y.csv",sep=""),header=T)
Y=Y[,1]


  ##########################################
  #5.use the generated Y and X_M to fit out model,jointly,PP
  ##(5.1)find a set of knots, using the centroids of each area
  ######read in locations of centroids
  ######get some dist matrix
  ######we already did this in (3.1)
  ##(5.2)fit model using PP
  ######(5.2.1)some global parameters
  n.T=10000
  n.burn0=20000
  n.burn=0
  n.tune=500
  times=5 #times for tune sigma
  step=2 #save posterior every stepth,so the total number is (n.T-n.burn)/step
  saveT3=(n.T-n.burn)/step
  #musave_p=rep(0,saveT3)
  sigma2save_p=rep(0,saveT3)
  phisave_p=rep(0,saveT3)
  etasave_p=matrix(0,nrow=saveT3,ncol=K)
  betasave_p=matrix(0,nrow=saveT3,ncol=P)
  tausave_p=rep(0,saveT3)
  probsave_p=matrix(0,nrow=saveT3,ncol=K)
  smrsave_p=matrix(0,nrow=saveT3,ncol=K)
  Esave_p=matrix(0,nrow=saveT3,ncol=K)
  Atau=Btau=1
  Asigma2=3
  Bsigma2=0.5
  Cphi=0.05
  Dphi=1/100
  Ephi=5*20
  Fphi=1*20
  ######(5.2.2)initalize
  mu=0
  sigma2=0.1
  phi=4.5
  X_star=X_cen
  X_all=c(X_M,X_star)
  H_all=exp(-phi*dist_all)
  Cov_all=sigma2*H_all
  Hs_all=solve(H_all)
  Covs_all=1/sigma2*Hs_all
  I_all=rep(1,(J+M))
  H_J=exp(-phi*dist_J)
  H_M=exp(-phi*dist_M)
  H_MJ=exp(-phi*dist_MJ)
  H_JL=exp(-phi*dist_JL)
  Hs_J=solve(H_J)
  #X_L is the predicted X_grid in PP
  #X_L=mu+t(H_JL)%*%Hs_J%*%(X_star-mu)
  X_L=X_grid
  matr1=t(H_JL)%*%Hs_J
  eta=eta_orig
  beta=c(b0,b1)
  #beta=rnorm(2,0,1)
  #tau=rgamma(1,Atau,Btau)
  tau=0.1
  omega0=1.5
  omega1=0.35
  omega11=0.2
  omega2=5
  omega_in_eta=rep(0.7,K)
  #omega_in_beta=c(0.05,0.01)
  omega_in_beta=c(0.05,0.03)
  omega_in_Xstar=rep(0.1,J)
  ######(5.2.3)start with burn-in
  acc_eta=rep(0,K)  #count for acceptance
  acc_beta=rep(0,P)
  acc_phi=0
  acc_Xstar=rep(0,J)
  beta1=beta2=rep(0,n.burn0)

  ######(5.2.4)start with burn-in
  for(nn in 1:n.burn0)
  {
   ########update mu, norm(Eu,Vu)
   #Vu=solve(t(I_all)%*%Covs_all%*%I_all)
   #Eu=Vu%*%t(I_all)%*%Covs_all%*%X_all
   #mu=rnorm(1,Eu,sd=sqrt(Vu)) 
   ########update sigma2, IG(anew,bnew)
   anew=Asigma2+(J+M)/2
   bnew=Bsigma2+0.5*(t(X_all-mu)%*%Hs_all%*%(X_all-mu))[1,1]
   sigma2=rigamma(1,anew,bnew)
   ########update phi
   theres=update_phi(phi,Cphi,Dphi,dist_all,sigma2,mu,X_all,Ephi,Fphi,acc_phi)
   phi=theres[[1]]
   acc_phi=theres[[2]]
   ########with the updated phi,we should updata H_all
   H_all=exp(-phi*dist_all)
   Cov_all=sigma2*H_all
   Hs_all=solve(H_all)
   Covs_all=1/sigma2*Hs_all
   H_J=exp(-phi*dist_J)
   H_M=exp(-phi*dist_M)
   H_MJ=exp(-phi*dist_MJ)
   H_JL=exp(-phi*dist_JL)
   Hs_J=solve(H_J)
   Hs_M=solve(H_M)
   matr1=t(H_JL)%*%Hs_J
   theE=mu+t(H_MJ)%*%Hs_M%*%(X_M-mu)
   theV=(H_J-t(H_MJ)%*%Hs_M%*%H_MJ)
   theVs=solve(theV)
   ########update X_star using MH
   #theres=update_Xstar2(X_star,X_M,beta,eta,matr1,Lk,mu,matr2,matr3,omega_in_Xstar,acc_Xstar)
   theres=update_Xstar3(X_star,X_M,beta,eta,matr1,Lk,mu,theE,theVs,omega_in_Xstar,acc_Xstar)
   X_star=theres[[1]]
   acc_Xstar=theres[[2]]
   ########after get X_star, we need update X_L
   X_all=c(X_M,X_star)
   X_L=mu+matr1%*%(X_star-mu)
   X_L_k=list(0)
   tmp=0
   for(k in 1:K)
   {
    #find the index of X_L in area k
    thenum=seq(tmp+1,tmp+Lk[k])
    tmp=tmp+Lk[k]
    X_L_k[[k]]=(X_L[thenum])
    #print(mean(X_L_k[[k]]))
   }
   ########update each eta using MH
   theres=update_eta1(W.mat,eta,beta,X_L_k,tau,omega_in_eta,acc_eta,3)
   eta=theres[[1]]
   acc_eta=theres[[2]]
   ########update each beta using M-H
   theres=update_beta(eta,beta,X_L_k,omega_in_beta,acc_beta,3)
   beta=theres[[1]]
   acc_beta=theres[[2]]
   beta1[nn]=beta[1]
   beta2[nn]=beta[2]
   ########update tau
   tau=update_tau(eta,Atau,Btau,W.mat)
  }   
   acc_eta=acc_eta/n.burn0
   acc_beta=acc_beta/n.burn0
   acc_phi=acc_phi/n.burn0
   acc_Xstar=acc_Xstar/n.burn0
   print(acc_beta)
   print(acc_phi)
   print(summary(acc_Xstar))
   print(summary(beta1))
   print(summary(beta2))
   if(mean(acc_Xstar)>0.35)
   {
    omega_in_Xstar=rep(0.3,J)
   }
   if(mean(acc_Xstar)<0.15)
   {
    omega_in_Xstar=rep(0.07,J)
   }

  ######(5.2.5)model fitting
  acc_eta=rep(0,K)  #count for acceptance
  acc_beta=rep(0,P)
  acc_phi=0
  acc_Xstar=rep(0,J)
  beta1=beta2=rep(0,n.T)
  for(nn in 1:n.T)
  {
   ########update mu, norm(Eu,Vu)
   #Vu=solve(t(I_all)%*%Covs_all%*%I_all)
   #Eu=Vu%*%t(I_all)%*%Covs_all%*%X_all
   #mu=rnorm(1,Eu,sd=sqrt(Vu)) 
   ########update sigma2, IG(anew,bnew)
   anew=Asigma2+(J+M)/2
   bnew=Bsigma2+0.5*(t(X_all-mu)%*%Hs_all%*%(X_all-mu))[1,1]
   sigma2=rigamma(1,anew,bnew)
   ########update phi
   theres=update_phi(phi,Cphi,Dphi,dist_all,sigma2,mu,X_all,Ephi,Fphi,acc_phi)
   phi=theres[[1]]
   acc_phi=theres[[2]]
   ########with the updated phi,we should updata H_all
   H_all=exp(-phi*dist_all)
   Cov_all=sigma2*H_all
   Hs_all=solve(H_all)
   Covs_all=1/sigma2*Hs_all
   H_J=exp(-phi*dist_J)
   H_M=exp(-phi*dist_M)
   H_MJ=exp(-phi*dist_MJ)
   H_JL=exp(-phi*dist_JL)
   Hs_J=solve(H_J)
   Hs_M=solve(H_M)
   matr1=t(H_JL)%*%Hs_J
   theE=mu+t(H_MJ)%*%Hs_M%*%(X_M-mu)
   theV=(H_J-t(H_MJ)%*%Hs_M%*%H_MJ)
   theVs=solve(theV)
   ########update X_star using MH
   #theres=update_Xstar2(X_star,X_M,beta,eta,matr1,Lk,mu,matr2,matr3,omega_in_Xstar,acc_Xstar)
   theres=update_Xstar3(X_star,X_M,beta,eta,matr1,Lk,mu,theE,theVs,omega_in_Xstar,acc_Xstar)
   X_star=theres[[1]]
   acc_Xstar=theres[[2]]
   ########after get X_star, we need update X_L
   X_all=c(X_M,X_star)
   X_L=mu+matr1%*%(X_star-mu)
   X_L_k=list(0)
   tmp=0
   for(k in 1:K)
   {
    #find the index of X_L in area k
    thenum=seq(tmp+1,tmp+Lk[k])
    tmp=tmp+Lk[k]
    X_L_k[[k]]=(X_L[thenum])
    #print(mean(X_L_k[[k]]))
   }
   ########update each eta using MH
   theres=update_eta1(W.mat,eta,beta,X_L_k,tau,omega_in_eta,acc_eta,3)
   eta=theres[[1]]
   acc_eta=theres[[2]]
   ########update each beta using M-H
   theres=update_beta(eta,beta,X_L_k,omega_in_beta,acc_beta,3)
   beta=theres[[1]]
   acc_beta=theres[[2]]
   beta1[nn]=beta[1]
   beta2[nn]=beta[2]
   ########update tau
   tau=update_tau(eta,Atau,Btau,W.mat)
   ########save posteriors after burnin
   if((nn>n.burn)&((nn-n.burn)%%step==0))
   {
    #musave_p[(nn-n.burn)/step]=mu
    sigma2save_p[(nn-n.burn)/step]=sigma2
    phisave_p[(nn-n.burn)/step]=phi
    #Xstarsave_p[(nn-n.burn)/step,]=X_ptar
    etasave_p[(nn-n.burn)/step,]=eta
    betasave_p[(nn-n.burn)/step,]=beta
    tausave_p[(nn-n.burn)/step]=tau
    p=rep(0,K)
    for(k in 1:K)
    {
     p[k]=mean((1+exp(-(beta[1]+beta[2]*X_L_k[[k]]+eta[k])))^(-1))
    }
    bb=sum(N*p)/sum(N)
    probsave_p[(nn-n.burn)/step,]=p
    smrsave_p[(nn-n.burn)/step,]=p/bb
    Esave_p[(nn-n.burn)/step,]=N*bb 
   }
  }
  acc_eta=acc_eta/n.T
  acc_beta=acc_beta/n.T
  acc_phi=acc_phi/n.T
  acc_Xstar=acc_Xstar/n.T
  print(acc_beta)
  print(acc_phi)
  print(summary(acc_Xstar))
  print(summary(beta1))
  print(summary(beta2))
  print("end PP")
  ####################################end for fit model with PP

  ######################################
  #6.after model fitting, get saved values
  write.csv(sigma2save_p,paste(dir,"sigma2save_p.csv",sep=""),row.names=F)
  write.csv(phisave_p,paste(dir,"phisave_p.csv",sep=""),row.names=F)
  write.csv(etasave_p,paste(dir,"etasave_p.csv",sep=""),row.names=F)
  write.csv(betasave_p,paste(dir,"betasave_p.csv",sep=""),row.names=F)
  write.csv(tausave_p,paste(dir,"tausave_p.csv",sep=""),row.names=F)
  write.csv(probsave_p,paste(dir,"probsave_p.csv",sep=""),row.names=F)
  write.csv(smrsave_p,paste(dir,"smrsave_p.csv",sep=""),row.names=F)
  write.csv(Esave_p,paste(dir,"Esave_p.csv",sep=""),row.names=F)


  beta_p_each_mean=apply(betasave_p,2,mean)
  beta_p_each_med=apply(betasave_p,2,median)
  beta_p_each_sd=apply(betasave_p,2,sd)
  beta_p_each_lower=apply(betasave_p,2,function(x){return(quantile(x,0.025))})
  beta_p_each_upper=apply(betasave_p,2,function(x){return(quantile(x,0.975))})
  beta_save_p=cbind(beta_p_each_mean,beta_p_each_med,beta_p_each_sd,beta_p_each_lower,beta_p_each_upper)
  write.csv(beta_save_p,paste(dir,"beta_save_p.csv",sep=""),row.names=F) 
  prob_p_each_mean=apply(probsave_p,2,mean)
  prob_p_each_med=apply(probsave_p,2,median)
  prob_p_each_sd=apply(probsave_p,2,sd)
  prob_p_each_lower=apply(probsave_p,2,function(x){return(quantile(x,0.025))})
  prob_p_each_upper=apply(probsave_p,2,function(x){return(quantile(x,0.975))})
  prob_save_p=cbind(prob_p_each_mean,prob_p_each_med,prob_p_each_sd,prob_p_each_lower,prob_p_each_upper)
  write.csv(prob_save_p,paste(dir,"prob_save_p.csv",sep=""),row.names=F) 
  smr_p_each_mean=apply(smrsave_p,2,mean)
  smr_p_each_med=apply(smrsave_p,2,median)
  smr_p_each_sd=apply(smrsave_p,2,sd)
  smr_p_each_lower=apply(smrsave_p,2,function(x){return(quantile(x,0.025))})
  smr_p_each_upper=apply(smrsave_p,2,function(x){return(quantile(x,0.975))})
  smr_save_p=cbind(smr_p_each_mean,smr_p_each_med,smr_p_each_sd,smr_p_each_lower,smr_p_each_upper)
  write.csv(smr_save_p,paste(dir,"smr_save_p.csv",sep=""),row.names=F) 